      module csa_data
!-----------------------------------------------------------------------------
! Maximum number of generated conformations
      integer,parameter :: mxio=1000
! Maximum number of n7 generated conformations
      integer,parameter :: mxio2=100
! Maxmimum number of angles per residue
      integer,parameter :: mxang=4
! Maximum number of chains
      integer,parameter :: mxch=1
!-----------------------------------------------------------------------------
! commom.bank
!      common/varin/
      real(kind=8),dimension(:,:,:,:),allocatable :: dihang_in !(mxang,maxres,mxch,mxio)
!      common/minvar/
!      real(kind=8),dimension(:,:,:,:),allocatable :: dihang !(mxang,maxres,mxch,mxio)
      real(kind=8),dimension(:),allocatable :: rmsn,pncn !(mxio)
!      integer,dimension(:),allocatable :: nss_out !(mxio)
!      integer,dimension(:,:),allocatable ::iss_out,jss_out !(maxss,mxio)
!      common/bank/
      real(kind=8),dimension(:,:,:,:),allocatable :: rvar,bvar!(mxang,maxres,mxch,mxio)
      real(kind=8),dimension(:),allocatable :: bene,rene,&
       brmsn,rrmsn,bpncn,rpncn !(mxio)
      integer,dimension(:),allocatable :: ibank!,is,jbank !(mxio)
      real(kind=8) :: cutdif,&!,avedif,difmin,ebmin,ebmax,ebmaxt,&
        dele,difcut,rmscut,pnccut
!      real(kind=8),dimension(:,:),allocatable :: dij !(mxio,mxio)
      integer :: ibmin,ibmax,nbank,ntbank,ntbankm,nconf,iuse,&
       nstep,icycle,iseed,iref,nconf_in,ilastnstep,nadd
!      common/bank_disulfid/
      integer,dimension(:),allocatable :: bvar_nss,bvar_ns !(mxio)
      integer,dimension(:,:),allocatable :: bvar_s !(maxss,mxio)
      integer,dimension(:,:,:),allocatable :: bvar_ss !(2,maxss,mxio)              
!-----------------------------------------------------------------------
! common.iounits
! I/O units used by the program
!-----------------------------------------------------------------------
! 9/18/99 - unit ifourier and filename fouriername included to identify
! the file from which the coefficients of second-order Fourier expansion
! of the local-interaction energy are read.
! 8/9/01 - file for SCP interaction constants named scpname (unit iscpp)
! included.
!-----------------------------------------------------------------------
! CSA I/O units & files
!      common /csafiles/
      character(len=256) :: csa_rbank,csa_seed,csa_history,csa_bank,&
       csa_bank1,csa_alpha,csa_alpha1,csa_bankt,csa_int,&
       csa_bank_reminimized,csa_native_int,csa_in
!      common /csaunits/
      integer :: icsa_rbank,icsa_seed,icsa_history,icsa_bank,&
       icsa_bank1,icsa_alpha,icsa_alpha1,icsa_bankt,icsa_int,&
       icsa_bank_reminimized,icsa_native_int,icsa_in,icsa_pdb
!-----------------------------------------------------------------------------
! common.csa
      integer :: irestart,ndiff
!      common/alphaa/
!      integer,dimension(:),allocatable :: ngroup !(mxgr)
!      integer,dimension(:,:,:),allocatable :: igroup !(3,mxang,mxgr)
      integer :: numch
!      common/csa_input/
      real(kind=8) :: cut1,cut2,estop
      real(kind=8) :: eglob_csa
      integer :: jstart,jend,&
       n1,n2,n3,n4,n5,n6,n7,n8,n9,n14,n15,n16,n17,n18,n0,&
       is1,is2,nseed,ntotal,icmax,nstmax,nran0,nran1,irr
      integer :: nglob_csa,nmin_csa
!      common/dih_control/
      real(kind=8) :: rdih_bias
!      common/diffcuta/
      real(kind=8) :: diffcut
!-----------------------------------------------------------------------------
! Maximum number of groups of angles
      integer :: mxgr
!-----------------------------------------------------------------------------
      real(kind=8) :: rmsdbc1
!-----------------------------------------------------------------------------
      end module csa_data
